Package: pfamAnalyzeR
Type: Package
Title: Identification of domain isotypes in pfam data
Version: 1.6.0
Authors@R: person(given="Kristoffer",family="Vitting-Seerup", role=c("cre","aut"),email="k.vitting.seerup@gmail.com",comment = c(ORCID = "0000-0002-6450-0608"))
Description: Protein domains is one of the most import annoation of proteins we have
    with the Pfam database/tool being (by far) the most used tool. This R package enables
    the user to read the pfam prediction from both webserver and stand-alone runs into R.
    We have recently shown most human protein domains exist as multiple distinct variants 
    termed domain isotypes. Different domain isotypes are used in a cell, tissue, and 
    disease-specific manner. Accordingly, we find that domain isotypes, compared to each other,
    modulate, or abolish the functionality of a protein domain. This R package enables the
    identification and classification of such domain isotypes from Pfam data.
License: MIT + file LICENSE
Depends: R (>= 4.3.0), readr, stringr, dplyr
Imports: utils, tibble, magrittr
Encoding: UTF-8
RoxygenNote: 7.2.1
Suggests: BiocStyle, knitr, rmarkdown
VignetteBuilder: knitr
biocViews: AlternativeSplicing, TranscriptomeVariant,
        BiomedicalInformatics, FunctionalGenomics, SystemsBiology,
        Annotation, FunctionalPrediction, GenePrediction, DataImport
BugReports: https://github.com/kvittingseerup/pfamAnalyzeR/issues
git_url: https://git.bioconductor.org/packages/pfamAnalyzeR
git_branch: RELEASE_3_20
git_last_commit: f54b196
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-30 02:08:25 UTC; biocbuild
Author: Kristoffer Vitting-Seerup [cre, aut]
    (<https://orcid.org/0000-0002-6450-0608>)
Maintainer: Kristoffer Vitting-Seerup <k.vitting.seerup@gmail.com>

#' Augment pfam domains with truncation/indel calculations
#' @param pfamRes
#' A data frame with pfam results as produced by \code{read_pfam}.
#' @return
#' The data.frame with the Pfam results now augmented with info on trunkation and indel sizes
#' @examples
#' ### Load pfam data
#' pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
#' pfamRes <- read_pfam(pfamResultFile)
#'
#' ### Augment the pfam data
#' pfamRes <- augment_pfam(pfamRes)
#'

augment_pfam <- function(
        pfamRes
) {
    ### Calculate truncation
    if(TRUE) {
        startMissing <- pfamRes$hmm_start - 1
        endMissing   <- pfamRes$hmm_length - pfamRes$hmm_end

        startFracMissing <- round( startMissing / pfamRes$hmm_length, digits = 3)
        endFracMissing   <- round( endMissing   / pfamRes$hmm_length, digits = 3)

        pfamRes$truncation_size <- base::pmax(endMissing      , startMissing )
        pfamRes$truncation_frac <- base::pmax(startFracMissing, endFracMissing)
    }

    ### Calculate indel
    if(TRUE) {
        pfamRes <-
            pfamRes  %>%
            tibble::as_tibble() %>%
            dplyr::mutate(
                hmm_alligned_length = hmm_end - hmm_start + 1,
                seq_alligned_length = envelope_end - envelope_start + 1,
                indel_size = seq_alligned_length - hmm_alligned_length,
                indel_frac = round( indel_size / hmm_alligned_length, digits = 3)
            ) %>%
            dplyr::select(-hmm_alligned_length,-seq_alligned_length)

    }
    # indel_size Postive : Sequence analyzed is longer  aka sequence insertion
    # indel_size Negative: Sequence analyzed is shorter aka sequence deletion

    return(pfamRes)
}

#' Read in and analyze pfam domains isotypes
#' @param path
#' A string indicating the full path to the Pfam result file
#' @param fracCutoff
#' The fraction of a protein domain that must be affected before classifying it a truncation or indel.
#' @return
#' The data.frame with the Pfam results now augmented with info about domain structural variation
#' @examples
#' ### Predict domain isotypes in pfam results
#' pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
#' pfamRes <- pfamAnalyzeR(pfamResultFile)

pfamAnalyzeR <- function(
    path,
    fracCutoff = 0.1
) {
    read_pfam(path) %>%
        augment_pfam() %>%
        analyse_pfam_isotypes(
            pfamRes = .,
            fracCutoff = fracCutoff
        ) %>%
        return()
}

#' Read Pfam file into R
#' @description
#' Read Pfam result file file into R. Supports both result files from local and web-server
#' @param path
#' A string indicating the full path to the Pfam result file
#' @details
#' The pfam webserver can be found at \url{https://www.ebi.ac.uk/Tools/hmmer/search/hmmscan}.
#' @return
#' A data.frame with the Pfam results
#' @examples
#' pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
#' pfamRes <- read_pfam(pfamResultFile)

read_pfam <- function(
    path
) {

    ### Figure out file type
    if(TRUE) {
        fileVector <- base::readLines(con = path, n = 3)

        if (! length(fileVector) ) {
            stop('The file pointed to by \'path\' is empty')
        }

        tapsAnnotated <- any(stringr::str_detect(fileVector, '\\t'))
    }
    # tapsAnnotated

    ### Figure out header and lines to skip
    if(TRUE) {
        ### Test whether headers are included
        temp <-
            utils::read.table(
                file = path,
                stringsAsFactors = FALSE,
                fill = TRUE,
                header = FALSE,
                nrows = 1
            )
        headerIncluded <- grepl('^<seq|^seq', temp[1, 1])

        ### Figure out number of lines to skip
        if(   headerIncluded) {
            tmp2 <-
                base::readLines(
                    con = path,
                    n = 50
                )
            skipLine <- which(grepl('^<seq|^seq', tmp2))[1]

            temp3 <-
                utils::read.table(
                    file = path,
                    stringsAsFactors = FALSE,
                    fill = TRUE,
                    header = FALSE,
                    nrows = 1,
                    skip = skipLine,
                )
        }
        if( ! headerIncluded) {
            skipLine <- 0
        }
    }
    # skipLine

    ### Read in file using the file type info extracted above
    if(TRUE) {
        if( tapsAnnotated ) {
            localPfamRes <- utils::read.table(
                file = path,
                stringsAsFactors = FALSE,
                fill = TRUE,
                header = FALSE,
                col.names = seq_len(16),
                sep = '\t',
                skip = skipLine
            )
        } else {
            localPfamRes <- utils::read.table(
                file = path,
                stringsAsFactors = FALSE,
                fill = TRUE,
                header = FALSE,
                col.names = seq_len(16),
                sep = '', # one or more white spaces
                skip = skipLine
            )
        }

    }

    ### Test for problems
    if(TRUE) {
        ### Determine if active sites are predicted
        activeResidueIncluded <- any(
            stringr::str_detect(
                string = localPfamRes[,ncol(localPfamRes)],
                pattern = 'predicted_active_site'
            ),
            na.rm = TRUE
        )

        ### Test shifted values
        testShiftedValues <- function(aDF) {
            try1 <- unique(c(
                which(is.na( aDF[,14]     )),              # via "significant" column (will either be NA or a clan indication)
                which(       aDF[,14] != 1 ),              # via "significant" column (will either be NA or a clan indication)
                which( ! stringr::str_detect(aDF[,6], '^PF|^PB') )  # via pfam_hmm id which should start with PF or PB
            ))

            return(try1)
        }
        try1problems <- testShiftedValues(localPfamRes)
        any(try1problems)
    }
    # FALSE

    ### Try with fwf
    if( any(try1problems) ) {
        ### Fix the mistake in the fixed width file
        suppressWarnings(
            fileVector <- readLines(path, encoding = 'UTF-8')
        )
        fileVector <- gsub('Coiled-coil',' Coiled', fileVector)

        ### FOr read_fwf to recognice it as raw text it must have new lines included
        fileVector <- stringr::str_c(fileVector, '\n')

        suppressMessages(
            suppressWarnings(
                localPfamRes2 <- readr::read_fwf(
                    file = fileVector,
                    col_positions = readr::fwf_empty(
                        file = fileVector,
                        col_names = paste0(
                            'X',
                            seq_len(15+ activeResidueIncluded + 1)
                        ),
                        skip = skipLine,
                        comment = '#',
                        n = 1000L
                    ),
                    skip = skipLine,
                    comment = '#'
                )
            )
        )
        localPfamRes2 <- as.data.frame(localPfamRes2)

        ### Test shifted values via "significant" column (will either be NA or a clan indication)
        try2problems <- testShiftedValues(localPfamRes2)

        ### overwrite if fewer problems
        if( length(try2problems) < length(try1problems) ) {
            localPfamRes <- localPfamRes2
        }
    }

    ### Set col names
    if(TRUE) {
        ### Define Colnames for pfam file types
        if(TRUE) {
            oldColnames <-
                c(
                    'seq_id',
                    'alignment_start',
                    'alignment_end',
                    'envelope_start',
                    'envelope_end',
                    'hmm_acc',
                    'hmm_name',
                    'type', # 8
                    'hmm_start',
                    'hmm_end',
                    'hmm_length',
                    'bit_score',
                    'e_value',
                    'significant', # 14
                    'clan',
                    'residue'
                )
            newColNames <-
                c(
                    'seq_id',
                    'alignment_start',
                    'alignment_end',
                    'envelope_start',
                    'envelope_end',
                    'hmm_acc',
                    'hmm_name',
                    'hmm_start', # 8
                    'hmm_end',
                    'hmm_length',
                    'bit_score',
                    'Individual_E_value',
                    'Conditional_E_value',
                    'significant', # 14
                    'outcompeted',
                    'clan'
                )
        }

        ### Define style via clan column
        oldStyle <- any(grepl('^CL', localPfamRes[,15]))
        if(ncol(localPfamRes) == 16 ) {
            newStyle <- any(grepl('^CL', localPfamRes[,16]))
        } else {
            newStyle <- FALSE
        }

        ### Old style
        if ( oldStyle & !newStyle ) {
            colnames(localPfamRes) <- oldColnames[seq_len(ncol(localPfamRes))]

            if( 'residue' %in% colnames(localPfamRes) ) {
                localPfamRes$residue[which(localPfamRes$residue == '')] <-
                    NA
            }
        }
    }

    return(localPfamRes)
}

## ----echo=FALSE, fig.align='left', out.width="85%"----------------------------
knitr::include_graphics("schemtic_overview.jpg")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(pfamAnalyzeR)

## ----locate file--------------------------------------------------------------
### Create sting pointing to result file
# note that you do not need to use the "system.file".
# That is only needed when accessing files in an R package
pfamResultFile <- system.file(
    "extdata/pfam_results.txt",
    package = "pfamAnalyzeR"
)

file.exists(pfamResultFile)

## ----run analysis-------------------------------------------------------------
### Run entire pfam analysis
pfamRes <- pfamAnalyzeR(pfamResultFile)

## ----explore results----------------------------------------------------------

### Look at a few entries
pfamRes %>% 
    select(seq_id, hmm_name, type, domain_isotype, domain_isotype_simple) %>% 
    head()

### Summarize domain isotype
table(pfamRes$domain_isotype)

### Summarize domain isotype
table(pfamRes$domain_isotype_simple)

## ----type cautions------------------------------------------------------------
table(
    pfamRes$type,
    pfamRes$domain_isotype_simple
)

## ----session info-------------------------------------------------------------
sessionInfo()

#' Determine domain isotype
#' @param pfamRes
#' A data frame with pfam augmneted with indel and truncation info (as produced by \code{augment_pfam}).
#' @param fracCutoff
#' The fraction of a protein domain that must be affected before classifying it a truncation or indel.
#' @return
#' The data.frame with the Pfam results now augmented with info about domain domain isotype
#' @examples
#' ### Load pfam data
#' pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
#' pfamRes <- read_pfam(pfamResultFile)
#'
#' ### Augment the pfam data
#' pfamRes <- augment_pfam(pfamRes)
#'
#' ### Predict domain isotype
#' pfamRes <- analyse_pfam_isotypes(pfamRes)

analyse_pfam_isotypes <- function(
    pfamRes,
    fracCutoff = 0.1
) {
    pfamRes %>%
        mutate(
            domain_isotype = dplyr::case_when(
                abs(indel_frac) <=  fracCutoff & truncation_frac <= fracCutoff ~ 'Reference',
                abs(indel_frac)  >  fracCutoff & truncation_frac  > fracCutoff ~ 'Complex',
                indel_frac       >  fracCutoff & truncation_frac <= fracCutoff ~ 'Insertion',
                indel_frac       < -fracCutoff & truncation_frac <= fracCutoff ~ 'Deletion',
                abs(indel_frac) <=  fracCutoff & truncation_frac  > fracCutoff ~ 'Truncation',
                TRUE ~ 'Something went wrong - contact author'
            ),
            domain_isotype_simple = dplyr::case_when(
                domain_isotype == 'Reference' ~ 'Reference',
                domain_isotype %in% c('Complex','Insertion','Deletion','Truncation') ~ 'Non-reference',
                TRUE ~ 'Something went wrong - contact author'
            )
        )
}

---
title: "Vignette for pfamAnalyzeR"
author: "Kristoffer Vitting-Seerup"
date: "`r format(Sys.time(), '%d %B, %Y')`"
output: 
   BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{pfamAnalyzeR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Background and Rational
Protein domains is one of the most import types of annotation we have for proteins. For such annotation the Pfam database/tool is (by far) the most used tool and the _de-facto_ way protein domains are currently defined. We have recently shown most human protein domains exist as multiple distinct variants termed domain isotypes - a until now overlooked aspect of protein domains. Domain isotypes are used in a cell, tissue, and  disease-specific manner. Accordingly, we find that domain isotypes, compared to each other, modulate, or abolish the functionality of a protein domain. For more information check our [preprint](https://doi.org/10.1101/2022.08.12.503740)

This R package enables the user to read the Pfam prediction from both webserver and stand-alone runs into R and afterwards identify and classification domain isotypes from Pfam results.

These 5 isotypes are the reference isotype and four isotypes that, compared to the reference isotype, are best described as a truncation, an insertion, a deletion, or combinations thereof ("complex") and are visualized in the figure below:

```{r, echo=FALSE, fig.align='left', out.width="85%"}
knitr::include_graphics("schemtic_overview.jpg")
```


# Installation

pfamAnalyzeR is part of the Bioconductor repository and community which means it is distributed with, and dependent on, Bioconductor. Installation of pfamAnalyzeR is easy and can be done from within the R terminal. If it is the first time you use Bioconductor (or don't know if you have used it), simply copy-paste the following into an R session to install the basic Bioconductor packages (will only done if you don't already have them):

    if (!requireNamespace("BiocManager", quietly = TRUE)){
        install.packages("BiocManager")
        BiocManager::install()
    }

If you already have installed Bioconductor, running these two commands will check whether updates for installed packages are available.

After you have installed the basic Bioconductor packages you can install pfamAnalyzeR by copy-pasting the following into an R session:

    BiocManager::install("pfamAnalyzeR")

This will install the pfamAnalyzeR package as well as other R packages that are needed for pfamAnalyzeR to work.


# Workflow

Lets take a look at how an analysis with pfamAnalyzeR looks

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

We start by loading the pfamAnalyzeR library.

```{r setup}
library(pfamAnalyzeR)
```

To showcase pfamAnalyzeR we have included the output of running a small toy dataset througth the pfam webserver in the R pacakge. This can be accessed as follows:

```{r locate file}
### Create sting pointing to result file
# note that you do not need to use the "system.file".
# That is only needed when accessing files in an R package
pfamResultFile <- system.file(
    "extdata/pfam_results.txt",
    package = "pfamAnalyzeR"
)

file.exists(pfamResultFile)
```
Now we can read in the Pfam result file and classify each domain into one of the 5 domain isotypes.

```{r run analysis}
### Run entire pfam analysis
pfamRes <- pfamAnalyzeR(pfamResultFile)
```

With this done we can explore the results a little:

```{r explore results}

### Look at a few entries
pfamRes %>% 
    select(seq_id, hmm_name, type, domain_isotype, domain_isotype_simple) %>% 
    head()

### Summarize domain isotype
table(pfamRes$domain_isotype)

### Summarize domain isotype
table(pfamRes$domain_isotype_simple)
```

From which it can be seen that a large fraction (!) of protein domains found in regular data are non-reference isotypes.

<br />

Please note that pfamAnalyzeR performs the isotype analysis regardless of Pfam result type:

```{r type cautions}
table(
    pfamRes$type,
    pfamRes$domain_isotype_simple
)
```

Meaning if you are only interested in a specific annotation type you will have to subset it yourself.

# SessionInfo
```{r session info}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyse_pfam_isotypes.R
\name{analyse_pfam_isotypes}
\alias{analyse_pfam_isotypes}
\title{Determine domain isotype}
\usage{
analyse_pfam_isotypes(pfamRes, fracCutoff = 0.1)
}
\arguments{
\item{pfamRes}{A data frame with pfam augmneted with indel and truncation info (as produced by \code{augment_pfam}).}

\item{fracCutoff}{The fraction of a protein domain that must be affected before classifying it a truncation or indel.}
}
\value{
The data.frame with the Pfam results now augmented with info about domain domain isotype
}
\description{
Determine domain isotype
}
\examples{
### Load pfam data
pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
pfamRes <- read_pfam(pfamResultFile)

### Augment the pfam data
pfamRes <- augment_pfam(pfamRes)

### Predict domain isotype
pfamRes <- analyse_pfam_isotypes(pfamRes)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_pfam.R
\name{read_pfam}
\alias{read_pfam}
\title{Read Pfam file into R}
\usage{
read_pfam(path)
}
\arguments{
\item{path}{A string indicating the full path to the Pfam result file}
}
\value{
A data.frame with the Pfam results
}
\description{
Read Pfam result file file into R. Supports both result files from local and web-server
}
\details{
The pfam webserver can be found at \url{https://www.ebi.ac.uk/Tools/hmmer/search/hmmscan}.
}
\examples{
pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
pfamRes <- read_pfam(pfamResultFile)
}

\name{pfamResultFile}
\alias{pfamResultFile}
\docType{data}

\title{
Example of Pfam webserver output
}

\description{
The output from the pfam web-server when running it on 135 protein sequences.
}

\details{
The 135 protein sequences were uploaded to the pfam webserver \url{https://www.ebi.ac.uk/Tools/hmmer/search/hmmscan} as an amino acid fasta file. An email was provided and the results here are copy/pasted from the email they send (as the website at the time of writing have no way to download all results).
}

\source{
The amino acid sequnces analyzed via the pfam server are from the example data in the IsoformSwitchAnalyzeR R package. More information on the data and how it was generated can be found here \code{?IsoformSwitchAnalyzeR::exampleSwitchListIntermediary}.

This data is only included to provide examples for usage of function. As it is modified to illustrate the package it should not be considered real and no biological conclusions should be made from it.
}

\examples{
pfamResultFile <- system.file(
    "extdata/pfam_results.txt",
    package = "pfamAnalyzeR"
)
pfamRes <- read_pfam(pfamResultFile)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/augment_pfam.R
\name{augment_pfam}
\alias{augment_pfam}
\title{Augment pfam domains with truncation/indel calculations}
\usage{
augment_pfam(pfamRes)
}
\arguments{
\item{pfamRes}{A data frame with pfam results as produced by \code{read_pfam}.}
}
\value{
The data.frame with the Pfam results now augmented with info on trunkation and indel sizes
}
\description{
Augment pfam domains with truncation/indel calculations
}
\examples{
### Load pfam data
pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
pfamRes <- read_pfam(pfamResultFile)

### Augment the pfam data
pfamRes <- augment_pfam(pfamRes)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pfamAnalyzeR.R
\name{pfamAnalyzeR}
\alias{pfamAnalyzeR}
\title{Read in and analyze pfam domains isotypes}
\usage{
pfamAnalyzeR(path, fracCutoff = 0.1)
}
\arguments{
\item{path}{A string indicating the full path to the Pfam result file}

\item{fracCutoff}{The fraction of a protein domain that must be affected before classifying it a truncation or indel.}
}
\value{
The data.frame with the Pfam results now augmented with info about domain structural variation
}
\description{
Read in and analyze pfam domains isotypes
}
\examples{
### Predict domain isotypes in pfam results
pfamResultFile <- system.file("extdata/pfam_results.txt", package = "pfamAnalyzeR")
pfamRes <- pfamAnalyzeR(pfamResultFile)
}
